///////////////////////////////////////////////////////////////////////////
//
// File					: h261ncs.h
//
// Description			: Header file for NCS H.261 DLL
//
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
//
// Codec initialization (common initialization for both coder and decoder)
// must be invoked before coder or/and decoder initialization
//
void p64InitCodec(void);

////////////////////////////////////////////////////////////////////////////////
// Encoder functions

// Intialization
void p64InitEncoder(void);

////////////////////////////////////////////////////////////////////////////////
// Encoding one frame
//
// Arguments:
//				inbuf - input buffer in YUV 411 format
//				outbuf- output buffer (H.261 stream)
// Result:
//				size of encoded frame
//
int p64EncodeFrame(char *inbuf, char *outbuf);
int p64EncodeIntraFrame(char *, char *);


////////////////////////////////////////////////////////////////////////////////
// Encoder functions

// Intialization
void p64InitDecoder(void);

////////////////////////////////////////////////////////////////////////////////
// Decoding one frame
//
// Arguments:
//				inbuf - input buffer (H.261 stream)
//				insize- size of input frame
//				outbuf- output buffer (YUV 411)
//				first - indicates if it is first frame from user
//				userno- unique user identification number
//
void p64DecodeFrame(char *inbuf, int insize, char *outbuf, int first, int userno);
