// AddUsers.cpp : implementation file
//

#include "stdafx.h"
#include "ncs.h"
#include "NCSmanager.h"
#include "AddUsers.h"
#include "conference.h"


extern NCSparticipant activeParts[];
extern int activePartsNum;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddUsers dialog


CAddUsers::CAddUsers(CWnd* pParent /*=NULL*/)
	: CDialog(CAddUsers::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddUsers)
	//}}AFX_DATA_INIT
}


void CAddUsers::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddUsers)
	DDX_Control(pDX, IDC_USER_EDIT, m_User);
	DDX_Control(pDX, IDC_INVITE_LIST, m_InvitedUsers);
	DDX_Control(pDX, IDC_ACTIVE_LIST, m_ActiveUsers);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddUsers, CDialog)
	//{{AFX_MSG_MAP(CAddUsers)
	ON_BN_CLICKED(IDC_ADD_BUT, OnAddBut)
	ON_BN_CLICKED(IDC_DEL_BUT, OnDelBut)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddUsers message handlers

void CAddUsers::OnAddBut() 
{
	char item[100];
	int pos;

	if((m_User.GetWindowText(item, 71)) > 0)
	{
		if(m_InvitedUsers.FindString(-1, item) == LB_ERR)
			m_InvitedUsers.AddString(item);
	}
	if((pos = m_ActiveUsers.GetCurSel()) != LB_ERR)
	{
		m_ActiveUsers.GetText(pos, item);
		if(m_InvitedUsers.FindString(-1, item) == LB_ERR)
			m_InvitedUsers.AddString(item);
	}
}

void CAddUsers::OnDelBut() 
{
	int pos;

	if((pos = m_InvitedUsers.GetCurSel()) != LB_ERR)
	{
		m_InvitedUsers.DeleteString(pos);
	}
}

void CAddUsers::OnOK() 
{
	int i, num;
	char item[100];

	num = m_InvitedUsers.GetCount();
	for(i=0; i<num; i++)
	{
		m_InvitedUsers.GetText(i, item);
		add_user(item);
	}
	
	CDialog::OnOK();
}

void CAddUsers::initActiveUsr(Participant *part, int num)
{
	char item[100];
	int i;

	for(i=0; i<num; i++)
	{
		wsprintf(item, "%s@%s", part[i].user, part[i].host);
		m_ActiveUsers.AddString(item);
	}
}



BOOL CAddUsers::OnInitDialog() 
{
	char item[100];
	int i;

	CDialog::OnInitDialog();
	
	for(i=0; i<activePartsNum; i++)
	{
		wsprintf(item, "%s@%s", activeParts[i].user, activeParts[i].host);
		m_ActiveUsers.AddString(item);
	}
	
	m_ActiveUsers.SetHorizontalExtent(200);
	m_InvitedUsers.SetHorizontalExtent(200);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
