#include <stdio.h>
#include <winsock.h>

#include "h261.h"

void RGB24toYUV(unsigned char *input, 
			 unsigned char *y, unsigned char *u, unsigned char *v, 
			 int width, int height)
{
	register int i, j;
	register unsigned char *in = input;
	register short cru, crv, lum;
	register unsigned char *y1 = y, *u1 = u, *v1 = v; 
	const int QCIFwidth = 176;
	const int QCIFheigth = 144;
	static boolean  first = TRUE;
    static float  mult299[1024], mult587[1024], mult114[1024];
    static float  mult16874[1024], mult33126[1024], mult5[1024];
    static float mult41869[1024], mult08131[1024];

    if ( first ) 
	{
        register int index;
		register int maxValue;

		maxValue = 256;

        for ( index = 0; index <= maxValue; index++ ) 
		{
			mult299[index] = index*0.29900;
			mult587[index] = index*0.58700;
			mult114[index] = index*0.11400;
			mult16874[index] = -0.16874*index;
			mult33126[index] = -0.33126*index;
			mult5[index] = index*0.50000;
			mult41869[index] = -0.41869*index;
			mult08131[index] = -0.08131*index;
		}
	
		first = FALSE;
    }

	for(i=0; i<QCIFheigth; i++)
	{
		for(j=0; j<QCIFwidth; j++)
		{
			lum =	 mult114[*(in)] 
				+	 mult587[*(in + 1)]
				+	 mult299[*(in + 2)];
			
			*(y1++) = (219*lum/255) + 16;

			if(((i%2) == 1) && ((j%2) == 1))
			{
				cru =	 mult5[*(in)] 
					+	 mult33126[*(in + 1)]
					+	 mult16874[*(in + 2)];

				*(u1++) = (224*cru/255) + 128;

				crv =	 mult08131[*(in)] 
					+	 mult41869[*(in + 1)]
					+	 mult5[*(in + 2)];

				*(v1++) = (224*crv/255) + 128;

			}
		}

		in += width - QCIFwidth;
	}
/*
	for(i=0; i<QCIFheigth; i++)
	{
		for(j=0; j<QCIFwidth; j++)
		{
			lum =	.299*(unsigned float)input[3*(i*width + j) + 2] 
				+	.587*(unsigned float)input[3*(i*width + j) + 1]
				+	.114*(unsigned float)input[3*(i*width + j)];
			
			lum = (float)((float)219/(float)255)*(unsigned float)lum + 16;
			y[(QCIFheigth-i-1)*QCIFwidth + (j)] = lum;

			if(((i%2) == 1) && ((j%2) == 1))
			{
				cru[0] =	(-0.1687)*(unsigned float)input[3*(i*width + j) + 2]
					+		(-0.3313)*(unsigned float)input[3*(i*width + j) + 1]
					+		(0.5)	 *(unsigned float)input[3*(i*width + j)];
				
				u[(((QCIFheigth-i-1)/2)*(QCIFwidth/2)) + ((j)/2)] = (unsigned char)((((float)224/(float)255)*(unsigned float)(cru[0])) + 128);

				crv[0] =	(0.5)    *(unsigned float)input[3*(i*width + j) + 2]
					+		(-0.4187)*(unsigned float)input[3*(i*width + j) + 1]
					+		(-0.0813)*(unsigned float)input[3*(i*width + j)];
				v[(((QCIFheigth-i-1)/2)*(QCIFwidth/2)) + ((j)/2)] = (unsigned char)((((float)224/(float)255)*(unsigned float)(crv[0])) + 128);
			}
		}
	}
	*/
}

void main()
{
	unsigned char buf1[130000];
	unsigned char buf[40000];
	char codedBuf[10000];
	int size, i;
	int beg, end;

	p64InitCodec();
	p64InitEncoder();
	p64InitDecoder();

	//p64setIntraMode();
	size = p64EncodeIntraFrame((char *)buf, codedBuf);
	
	beg = GetTickCount();
	for(i=0; i<100; i++)
	{
		RGB24toYUV(buf1, buf, &buf[25344], &buf[25344+6336], 240, 180);
		size = p64EncodeFrame((char *)buf, codedBuf);
	}
	end = GetTickCount();

	printf("Time per frame: %f ms\n", (double)(end - beg)/100);
}