#include <stdio.h>
#include <winsock.h>

#include "event.h"

long gethostid()
{
  char tmp[100];
  struct hostent *hostinfo;
  int id;
  
  gethostname(tmp, 100);
	  
  hostinfo = gethostbyname(tmp);
  if(hostinfo == NULL)
    {
      return -1;
    }

  id = *(long *)hostinfo->h_addr;
  return id;
}

NCSevent::NCSevent()
{
  active = 0;
}

NCSevent::~NCSevent()
{
}

int NCSevent::save(FILE *fd)
{
  if(active)
    {
      fwrite(&type, sizeof(int), 1, fd);
      fwrite(&timestamp, sizeof(struct timeval), 1, fd);
      fwrite(&port, sizeof(int), 1, fd);
      fwrite(&data_lenght, sizeof(int), 1, fd);
      if(data_lenght > 0)
		fwrite(data, data_lenght, 1, fd);
	  if(ferror(fd))
		perror("Write error\n");
	  fflush(fd);
    }

  return 1;
}

int NCSevent::restore(FILE *fd)
{
  fread(&type, sizeof(int), 1, fd);
  fread(&timestamp, sizeof(struct timeval), 1 ,fd);
  fread(&port, sizeof(int), 1, fd);
  fread(&data_lenght, sizeof(int), 1, fd);
  if(data_lenght > 0)
    fread(data, data_lenght, 1, fd);

  return 1;
}

int NCSevent::send(int sock)
{
  if(active)
    {
      addr.sin_family = AF_INET;
      addr.sin_port = htons(port);
      addr.sin_addr.s_addr = gethostid();
      sendto(sock, data, data_lenght, 0, (struct sockaddr *)&addr, sizeof(struct sockaddr_in));
    }

  return 1;
}

int NCSevent::receive(int sock)
{
  int len;
  DWORD msec;
  
  len = sizeof(struct sockaddr);
  data_lenght = recvfrom(sock, data, MAX_UDP_SIZE, 0, (struct sockaddr *)&addr, &len);
  msec = GetTickCount();
  timestamp.tv_sec = msec/1000;
  timestamp.tv_usec = (msec % 1000) * 1000;
  port = ntohs(addr.sin_port) - 2;
  type = ncsEventData;
  active = 1;

  return 1;
}

