// BuenaVistaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BuenaVista.h"
#include "BuenaVistaDlg.h"
#include "OptionDlg.h"
#include "Conference.h"
#include "Audio.h"
#include "AudioStat.h"
#include "ChatDlg.h"
#include "video.h"
#include "display.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuenaVistaDlg dialog

CBuenaVistaDlg::CBuenaVistaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBuenaVistaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBuenaVistaDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_hMicBmp = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MIC_BITMAP));
	m_hSpeakerBmp = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_SPEAKER_BITMAP));
	m_hCameraBmp = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_CAMERA_BITMAP));


}

void CBuenaVistaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBuenaVistaDlg)
	DDX_Control(pDX, IDC_USERS_LIST, m_UsersList);
	DDX_Control(pDX, IDC_STATUS_EDIT, m_StatusEdit);
	DDX_Control(pDX, IDC_SPEAKER_IND, m_SpeakerInd);
	DDX_Control(pDX, IDC_SPEAKER_CTRL, m_SpeakerCtrl);
	DDX_Control(pDX, IDC_MIC_IND, m_MicInd);
	DDX_Control(pDX, IDC_MIC_CTRL, m_MicCtrl);
	DDX_Control(pDX, IDC_MANUAL_CHECK, m_ManualCheck);
	DDX_Control(pDX, IDC_CAMERA_CHECK, m_CameraCheck);
	DDX_Control(pDX, IDC_AUTO_CHECK, m_AutoCheck);
	DDX_Control(pDX, IDC_AUDIO_CHECK, m_AudioCheck);
	DDX_Control(pDX, ID_PARTICIPANTS_REJECTINVITATION, m_RejectButton);
	DDX_Control(pDX, ID_PARTICIPANTS_ACCEPTINVITATION, m_AcceptButton);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBuenaVistaDlg, CDialog)
	//{{AFX_MSG_MAP(CBuenaVistaDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_PARTICIPANTS_ACCEPTINVITATION, OnParticipantsAcceptinvitation)
	ON_BN_CLICKED(ID_PARTICIPANTS_ADD, OnParticipantsAdd)
	ON_BN_CLICKED(ID_PARTICIPANTS_REJECTINVITATION, OnParticipantsRejectinvitation)
	ON_BN_CLICKED(IDC_AUDIO_CHECK, OnAudioCheck)
	ON_BN_CLICKED(IDC_AUTO_CHECK, OnAutoCheck)
	ON_BN_CLICKED(IDC_CAMERA_CHECK, OnCameraCheck)
	ON_BN_CLICKED(IDC_MANUAL_CHECK, OnManualCheck)
	ON_WM_HSCROLL()
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_FILE_RESETSESSION, OnFileResetsession)
	ON_COMMAND(ID_VIEW_AUDIOPANEL, OnViewAudiopanel)
	ON_COMMAND(ID_VIEW_STATISTICS, OnViewStatistics)
	ON_COMMAND(ID_EDIT_OPTIONS, OnEditOptions)
	ON_COMMAND(IDM_CHAT, OnChat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuenaVistaDlg message handlers

BOOL CBuenaVistaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetAudioCheck(TRUE);
	m_CameraCheck.SetBitmap(m_hCameraBmp);
	this->EnableInvitationButtons(FALSE);
	this->SetMicCtrl(20);
	this->SetSpeakerCtrl(20);
	this->SetStatus("Initialization...please wait");
	
	conference = (void *)new Conference(this);
	video = (void *)new Video(this, ((Conference *)conference)->getSessionInfo());
	audio = NULL;
	
	audioStat = (void *)new CAudioStat(((Conference *)conference)->getSessionInfo());
	((CAudioStat *)audioStat)->Create(IDD_ASTAT_DLG);
	
	chat = (void *)new CChatDlg(((Conference *)conference)->getSessionInfo());
	((CChatDlg *)chat)->Create(IDD_CHAT_DLG);

	m_AudioCheck.EnableWindow(FALSE);
	m_AutoCheck.EnableWindow(FALSE);
	m_ManualCheck.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBuenaVistaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CBuenaVistaDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBuenaVistaDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBuenaVistaDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/////////////////////////////////////////////////////////////////////////////////
//
// User controls callbacks
//
/////////////////////////////////////////////////////////////////////////////////
void CBuenaVistaDlg::OnParticipantsAcceptinvitation() 
{
	((Conference *)conference)->accept();	
}

void CBuenaVistaDlg::OnParticipantsAdd() 
{
	((Conference *)conference)->addUserCallback();
}

void CBuenaVistaDlg::OnParticipantsRejectinvitation() 
{
	((Conference *)conference)->reject();	
}

void CBuenaVistaDlg::OnAudioCheck() 
{
	if(m_AudioCheck.GetCheck())
		m_AudioCheck.SetBitmap(m_hMicBmp);
	else
		m_AudioCheck.SetBitmap(m_hSpeakerBmp);

	((Audio *)audio)->setTalk(m_AudioCheck.GetCheck());
}

void CBuenaVistaDlg::OnAutoCheck() 
{
	if(m_AutoCheck.GetCheck())
	{
		((Audio *)audio)->setManual(FALSE);	
		m_ManualCheck.SetCheck(FALSE);
	}
	((Audio *)audio)->setAuto(m_AutoCheck.GetCheck());	
}

void CBuenaVistaDlg::OnCameraCheck() 
{
	if(m_CameraCheck.GetCheck())
		((Video *)video)->Play();
	else
		((Video *)video)->Stop();
}

void CBuenaVistaDlg::OnManualCheck() 
{
	if(m_ManualCheck.GetCheck())
	{
		((Audio *)audio)->setAuto(FALSE);		
		m_AutoCheck.SetCheck(FALSE);
	}
	((Audio *)audio)->setManual(m_ManualCheck.GetCheck());		
}

void CBuenaVistaDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(nSBCode == TB_THUMBPOSITION)
	{
		if((void *)pScrollBar == (void *)&m_SpeakerCtrl)
		{
			if(audio != NULL)
				((Audio *)audio)->setTreshold(nPos);
		}
		
		if((void *)pScrollBar == (void *)&m_MicCtrl)
		{
			if(audio != NULL)
				((Audio *)audio)->setMicTreshold(nPos);
		}
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

/////////////////////////////////////////////////////////////////////////////////
//
// User controls settings
//
/////////////////////////////////////////////////////////////////////////////////
void CBuenaVistaDlg::SetStatus(char *string)
{
	m_StatusEdit.SetSel(0, -1);
	m_StatusEdit.ReplaceSel(string);
}

void CBuenaVistaDlg::SetSpeakerInd(int value)
{
	m_SpeakerInd.SetPos(value);
}

void CBuenaVistaDlg::SetSpeakerCtrl(int value)
{
	m_SpeakerCtrl.SetPos(value);
}

void CBuenaVistaDlg::SetMicInd(int value)
{
	m_MicInd.SetPos(value);
}

void CBuenaVistaDlg::SetMicCtrl(int value)
{
	m_MicCtrl.SetPos(value);
}

void CBuenaVistaDlg::Add2UserList(char *user, char *host)
{
	char text[100];

	strcpy(text, user);
	strcat(text, "@");
	strcat(text, host);
	m_UsersList.AddString(text);
}

void CBuenaVistaDlg::DeleteFromUserList(char *user, char *host)
{
	int index;
	char text[100];

	strcpy(text, user);
	strcat(text, "@");
	strcat(text, host);
	if((index = m_UsersList.FindString(-1, text)) != LB_ERR)
		m_UsersList.DeleteString(index);
}

void CBuenaVistaDlg::DeleteAllUsers()
{
	m_UsersList.ResetContent();
}

void CBuenaVistaDlg::SetSwitchChecks(BOOL autoswitch, BOOL manual)
{
	if(autoswitch)
		m_AutoCheck.SetCheck(1);
	else
		m_AutoCheck.SetCheck(0);

	if(manual)
		m_ManualCheck.SetCheck(1);
	else
		m_ManualCheck.SetCheck(0);

}

void CBuenaVistaDlg::EnableInvitationButtons(BOOL enable)
{
	if(enable)
	{
		m_AcceptButton.EnableWindow();
		m_RejectButton.EnableWindow();
	}
	else
	{
		m_AcceptButton.EnableWindow(FALSE);
		m_RejectButton.EnableWindow(FALSE);
	}
}

void CBuenaVistaDlg::SetAudioCheck(BOOL mic)
{
	if(mic)
	{
		m_AudioCheck.SetCheck(1);
		m_AudioCheck.SetBitmap(m_hMicBmp);
	}
	else
	{
		m_AudioCheck.SetCheck(0);
		m_AudioCheck.SetBitmap(m_hSpeakerBmp);
	}
}

void CBuenaVistaDlg::OnClose() 
{
	Conference *tmp;
	Audio *tmpa;
	Video *tmpv;

	tmp = (Conference *)conference;
	tmpv = (Video *)video;
	delete tmpv;
	if(audio != NULL)
	{
		tmpa = (Audio *)audio;
		delete tmpa;
	}

	delete tmp;
	CDialog::OnClose();
}

void CBuenaVistaDlg::OnFileExit() 
{
	Conference *tmp;
	Video *tmpv;
	Audio *tmpa;

	tmp = (Conference *)conference;
	tmpv = (Video *)video;
	delete tmpv;
	if(audio != NULL)
	{
		tmpa = (Audio *)audio;
		delete tmpa;
	}
	delete tmp;
	CDialog::EndDialog(0);
}

void CBuenaVistaDlg::OnFileResetsession() 
{
	Video *tmpv;
	Audio *tmpa;
	
	tmpv = (Video *)video;
	delete tmpv;
	if(audio != NULL)
	{
		tmpa = (Audio *)audio;
		delete tmpa;
	}

	((Conference *)conference)->resetSession();
	DeleteAllUsers();
	video = (void *)new Video(this, ((Conference *)conference)->getSessionInfo());
	audio = NULL;
}

void CBuenaVistaDlg::OnViewAudiopanel() 
{
	int len;
	char path[100];
	char name[20] = "windir";
	char winpath[100];

	len = GetEnvironmentVariable(name, winpath, 80);
	strcpy(path, winpath);
	strcat(path, "\\sndvol32.exe");
	if(!startProcess(path))
	{
		strcpy(path, winpath);
		strcat(path, "\\system32\\sndvol32.exe");
		startProcess(path);
	}
}

void CBuenaVistaDlg::OnViewStatistics() 
{
	((CAudioStat *)audioStat)->Init();	
	((CAudioStat *)audioStat)->ShowWindow(SW_SHOW);	
}

void CBuenaVistaDlg::OnEditOptions() 
{
	BOOL stopped;
	CDialog *dlg = new COptionDlg(this, &(((Conference *)conference)->options));
	
	stopped = ((Video *)video)->Stop();
	dlg->DoModal();
	if (stopped)
		((Video *)video)->Play();
}

void CBuenaVistaDlg::EnableAudioCheck(BOOL enable)
{
	m_AudioCheck.EnableWindow(enable);
}

void CBuenaVistaDlg::startAudio()
{
	m_AudioCheck.EnableWindow();
	m_AutoCheck.EnableWindow();
	m_ManualCheck.EnableWindow();
	audio = (void *)new Audio(this, ((Conference *)conference)->getSessionInfo());	
	displaySetStatus(MAX_USERS, "Audio On");

	((Video *)video)->Init();	
}

BOOL CBuenaVistaDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	switch(HIWORD(wParam))
	{
	case CREATE_DISPLAY:
		displayOpen(LOWORD(wParam));
		return TRUE;
		break;

	case DESTROY_DISPLAY:
		displayClose(LOWORD(wParam));
		return TRUE;
		break;

	case UPDATE_RATE:
		((Video *)video)->UpdateRate();
		return TRUE;
		break;
	}

	return CDialog::OnCommand(wParam, lParam);
}

BOOL CBuenaVistaDlg::startProcess(char *path)
{
	STARTUPINFO sinfo;
	PROCESS_INFORMATION pinfo;

	sinfo.cb = sizeof(STARTUPINFO);
	sinfo.lpReserved = NULL;
	sinfo.lpDesktop = NULL;
	sinfo.lpTitle = NULL;
	sinfo.dwFlags = STARTF_FORCEONFEEDBACK;
	sinfo.cbReserved2 = 0;
	sinfo.lpReserved2 = NULL;

	if(CreateProcess(path, NULL, NULL, NULL, FALSE, 
					NORMAL_PRIORITY_CLASS | DETACHED_PROCESS, NULL, NULL, 
					&sinfo, &pinfo)
		== FALSE)
		return FALSE;
		//MessageBox("Create process error");

	return TRUE;
}

void CBuenaVistaDlg::OnChat() 
{
	((CChatDlg *)chat)->ShowWindow(SW_SHOW);	
}
