// BuenaVistaDlg.h : header file
//

#ifndef _BVDLG_H
#define _BVDLG_H

/////////////////////////////////////////////////////////////////////////////
// CBuenaVistaDlg dialog

class CBuenaVistaDlg : public CDialog
{
// Construction
public:
	void * chat;
	void *conference;
	void *audio;
	void *video;
	void *audioStat;

	void startAudio();
	void EnableAudioCheck(BOOL enable = TRUE);
	void SetAudioCheck(BOOL mic);
	void EnableInvitationButtons(BOOL enable=TRUE);
	void SetSwitchChecks(BOOL autoswitch, BOOL manual);
	void Add2UserList(char *user, char *host);
	void DeleteFromUserList(char *user, char *host);
	void DeleteAllUsers();
	void SetSpeakerInd(int value);
	void SetMicInd(int value);
	void SetSpeakerCtrl(int value);
	void SetMicCtrl(int value);
	void SetStatus(char *string);
	CBuenaVistaDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBuenaVistaDlg)
	enum { IDD = IDD_BUENAVISTA_DIALOG };
	CListBox	m_UsersList;
	CEdit	m_StatusEdit;
	CProgressCtrl	m_SpeakerInd;
	CSliderCtrl	m_SpeakerCtrl;
	CProgressCtrl	m_MicInd;
	CSliderCtrl	m_MicCtrl;
	CButton	m_ManualCheck;
	CButton	m_CameraCheck;
	CButton	m_AutoCheck;
	CButton	m_AudioCheck;
	CButton	m_RejectButton;
	CButton	m_AcceptButton;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBuenaVistaDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL startProcess(char *path);
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBuenaVistaDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnParticipantsAcceptinvitation();
	afx_msg void OnParticipantsAdd();
	afx_msg void OnParticipantsRejectinvitation();
	afx_msg void OnAudioCheck();
	afx_msg void OnAutoCheck();
	afx_msg void OnCameraCheck();
	afx_msg void OnManualCheck();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnClose();
	afx_msg void OnFileExit();
	afx_msg void OnFileResetsession();
	afx_msg void OnViewAudiopanel();
	afx_msg void OnViewStatistics();
	afx_msg void OnEditOptions();
	afx_msg void OnChat();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	HBITMAP m_hCameraBmp;
	HBITMAP m_hSpeakerBmp;
	HBITMAP m_hMicBmp;
};

#endif

