// VideoOpt.cpp : implementation file
//

#include "stdafx.h"
#include "BuenaVista.h"
#include "VideoOpt.h"
#include "video.h"
#include "capture.h"
#include "options.h"

#include <vfw.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVideoOpt dialog


CVideoOpt::CVideoOpt(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoOpt::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoOpt)
	//}}AFX_DATA_INIT
}


void CVideoOpt::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoOpt)
	DDX_Control(pDX, IDC_FPSSLD, m_Fpssld);
	DDX_Control(pDX, IDC_RECOFF, m_RecOff);
	DDX_Control(pDX, IDC_COMPRESSION, m_Compression);
	DDX_Control(pDX, IDC_CAPTDEV, m_CaptDev);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVideoOpt, CDialog)
	//{{AFX_MSG_MAP(CVideoOpt)
	ON_BN_CLICKED(IDC_FORMAT, OnFormat)
	ON_BN_CLICKED(IDC_SOURCE, OnSource)
	ON_BN_CLICKED(IDC_NORMALBUT, OnNormalbut)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoOpt message handlers

void CVideoOpt::OnFormat() 
{
	int sel;
	
	sel = m_CaptDev.GetCurSel();	
	captureFormatDlg();
}

void CVideoOpt::OnSource() 
{
	captureSourceDlg();
}

BOOL CVideoOpt::OnInitDialog() 
{
	char name[40];
	char version[20];
	int i = 0;

	CDialog::OnInitDialog();
	
	while(capGetDriverDescription(i, name, 40, version, 20))
	{
		m_CaptDev.AddString(name);
		i++;
	}

	m_CaptDev.SetCurSel(0);

	m_Compression.AddString("H.263");
	m_Compression.AddString("H.261");
	m_Compression.AddString("H.261 intra");
	m_Compression.AddString("YUV9");
	
	m_Fpssld.SetRange(0, 10);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CVideoOpt::SetOptions(Options *opt)
{
	options = opt;

	switch(options->video.compression)
	{
	case H263:
		m_Compression.SetCurSel(0);
		break;

	case H261:
		if(options->video.intraMode)
			m_Compression.SetCurSel(2);			
		else
			m_Compression.SetCurSel(1);
		break;

	case YUV9:
		m_Compression.SetCurSel(3);
		break;
	}

	m_RecOff.SetCheck(options->video.recOff);

	m_Fpssld.SetPos(options->video.limit);
	m_CaptDev.SetCurSel(options->video.device);
}

void CVideoOpt::OnNormalbut() 
{
	options->video.limit = options->video.maxlimit;
	m_Fpssld.SetPos(options->video.limit);
}
