#ifndef _OPTIONS_H
#define _OPTIONS_H

#define H263 0
#define H261 1   
#define YUV9 10   

#define ADPCM 13
#define GSM 14
#define PCM 15

#define DUPLEX 20
#define HALF_DUPLEX 21

typedef struct _audio_options
{
	int compression;
	BOOL autoSwitch;
	BOOL manualSwitch;
	int speakerTreshold;
	int micTreshold;
	int mode;
	int volume;
	int micGain;
	BOOL mute;
	BOOL micOff;
	void *audioOut;
} AudioOptions;

typedef struct _video_options
{
	int device;
	int compression;
	BOOL intraMode;
	int limit;
	int maxlimit;
	BOOL recOff;
} VideoOptions;

typedef struct _options
{
	char connection[20];
	char server_name[50];
	char user_name[30];
	BOOL autoAccept;
	AudioOptions audio;
	VideoOptions video;
} Options;

#endif

