#include "ManagerTango.h"
#include "ncs.h"

#define PLUGINS_CFG_PATH "PLUGINS.CFG"
#define DAEMON_PATH "Core\\BVengine.exe"


typedef struct _plugin
{
	int port;
	char name[50];
	char path[100];
	int started;
	PROCESS_INFORMATION info;
} PLUGIN; 

typedef struct _tangoMsg
{
  unsigned char tag;
  NCSparticipant part;
} TangoMsg;

int start_conference(CManagerTangoDlg *dlg);
void exit_conference(void);
void add_member(char *user, char *host);
void add_user(char *member);
void read_plugins(void);
void quit_plugins(void);
void startProcess(char *path, PROCESS_INFORMATION *pinfo);
void create_app(int port);
void start_local_app(int index);
void quit_application(int port);
void quit_local_app(int index);
void info_app(int index);
void tangoAck(void);
void getStartPath(char *path);

// NCS callbacks
void invited(void *data);
void start_app(void *data);
void accepted(void *data);

// reading thread
DWORD readingThread(LPDWORD data);
