// ManagerTangoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ManagerTango.h"
#include "ManagerTangoDlg.h"
#include "Conference.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CManagerTangoDlg dialog

CManagerTangoDlg::CManagerTangoDlg(int aid, int port, CWnd* pParent /*=NULL*/)
	: CDialog(CManagerTangoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManagerTangoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	tangoAID = aid;
	tangoPort = port;
}

void CManagerTangoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManagerTangoDlg)
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CManagerTangoDlg, CDialog)
	//{{AFX_MSG_MAP(CManagerTangoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RUN, OnRun)
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	ON_BN_CLICKED(IDC_INFO, OnInfo)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManagerTangoDlg message handlers

BOOL CManagerTangoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	start_conference(this);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CManagerTangoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CManagerTangoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CManagerTangoDlg::AddApp(char *app)
{
	m_list.AddString(app);
}

void CManagerTangoDlg::OnRun() 
{
	int index;
	
	if((index = m_list.GetCurSel()) != LB_ERR)
		start_local_app(index);
}

void CManagerTangoDlg::OnQuit() 
{
	int index;
	
	if((index = m_list.GetCurSel()) != LB_ERR)
		quit_local_app(index);
}

void CManagerTangoDlg::OnInfo() 
{
	int index;
	
	if((index = m_list.GetCurSel()) != LB_ERR)
		info_app(index);
}

void CManagerTangoDlg::OnClose() 
{
	exit_conference();
	
	CDialog::OnClose();
}

void CManagerTangoDlg::SetStatus(char *text)
{
	m_Status.SetSel(0, -1);
	m_Status.ReplaceSel(text);
}
