/* database.c	-- Tomasz Stachowiak Fri Feb 14 1997
 * Time-stamp: <97/02/21 20:02:01 stach>
 */
#include <stdio.h>
#include <winsock.h>

#include "common.h"
#include "database.h"

#define RECORDER_PORT 55555

extern int database;

int dbSocket;
struct sockaddr_in dbAddr;

int dbInit(int port)
{
  struct sockaddr_in addr;

  if ((dbSocket = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    {
      fprintf(stderr, "Application: can't open socket\n");
      return 0;
    }
    
  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = htonl(INADDR_ANY);
  addr.sin_port        = htons(port);
  
  if(bind(dbSocket, (struct sockaddr *)&addr, sizeof(struct sockaddr_in)) < 0)
    {
      fprintf(stderr, "Application: can't bind socket\n");
      return 0;
    }

  dbAddr.sin_family = AF_INET;
  dbAddr.sin_port = htons(RECORDER_PORT);
  dbAddr.sin_addr.s_addr = gethostid();

  database = 1;
  return 1;
}

void dbClose()
{
  database = 0;
  closesocket(dbSocket);
}

int dbAdd(char *msg, int len)
{
  if(sendto(dbSocket, msg, len, 
	    0, (struct sockaddr *)&dbAddr, sizeof(struct sockaddr_in)) < 0)
    {
      fprintf(stderr, "Application: database send error\n");
      return 0;  
    }

  return 1;

}

